unit ifLife;


interface
uses informationfield, BoolField;

type               //   
  CifLife = class(CInformatiomField)
    public
      procedure OneStep(
        ColCount, RowCount: Longint;
        var boolCell: TBoolField; var trackCell: TBoolField;
        var nextPopulation: Longint;
        var bornPopulation, todPopulation: Integer ); override;
  end;

var
  curIfLife: CifLife;


implementation
uses Windows, Sysutils;

procedure CifLife.OneStep(
      ColCount, RowCount: Longint;
      var boolCell: TBoolField; var trackCell: TBoolField;
      var nextPopulation: Longint;
      var bornPopulation, todPopulation: Integer );
var i, j, l: Longint;
//var neighbourCells: array[0..7] of Boolean;
var neighbourNum: array[0..7, 0..1] of Integer;
var neighboursCount: Integer;
var tmpBoolCell: TBoolField;

begin
  SetLength(tmpBoolCell, ColCount, RowCount);
  bornPopulation := 0;
  todPopulation := 0;

  for  i:=0 to ColCount-1 do
    for j:=0 to RowCount-1 do begin
      neighbourNum[0, 0] := i-1;
      neighbourNum[0, 1] := j;
      neighbourNum[1, 0] := i-1;
      neighbourNum[1, 1] := j-1;
      neighbourNum[2, 0] := i;
      neighbourNum[2, 1] := j-1;
      neighbourNum[3, 0] := i+1;
      neighbourNum[3, 1] := j-1;
      neighbourNum[4, 0] := i+1;
      neighbourNum[4, 1] := j;
      neighbourNum[5, 0] := i+1;
      neighbourNum[5, 1] := j+1;
      neighbourNum[6, 0] := i;
      neighbourNum[6, 1] := j+1;
      neighbourNum[7, 0] := i-1;
      neighbourNum[7, 1] := j+1;
      neighboursCount:=0;
      for l:=0 to 7 do begin
        if neighbourNum[l,0] < 0 then neighbourNum[l,0] := ColCount-1;
        if neighbourNum[l,0] > ColCount-1 then neighbourNum[l,0] := 0;
        if neighbourNum[l,1] < 0 then neighbourNum[l,1] := RowCount-1;
        if neighbourNum[l,1] > RowCount-1 then neighbourNum[l,1] := 0;
        if boolCell[neighbourNum[l,0], neighbourNum[l,1]] then
          Inc(neighboursCount);
      end;

      if boolCell[i,j] then begin
        if  (neighboursCount<2) OR (neighboursCount>3) then begin
          tmpBoolCell[i,j] := False;
          Inc(todPopulation);
        end
        else begin
          tmpBoolCell[i,j] := True;
//          Inc(bornPopulation);
        end;
      end
      else begin
         if  neighboursCount = 3 then begin
           tmpBoolCell[i,j] := True;
           Inc(bornPopulation);
         end
         else begin
          tmpBoolCell[i,j] := False;
 //         Inc(todPopulation);
         end;

      end;
  end;   //for i,j

  nextPopulation := 0;
  for  i:=0 to ColCount-1 do
    for j:=0 to RowCount-1 do begin
      boolCell[i,j] := tmpBoolCell[i,j];
      if boolCell[i,j] then Inc(nextPopulation);

  end;



end;




end.
