unit lifeThread;

interface

uses Windows, Sysutils, Classes;

type
  CLifeThread = class(TThread)
  private
    { Private declarations }
  protected
    procedure Execute; override;
  end;

var
  ifThread: CLifeThread;

implementation
uses main;
{ Important: Methods and properties of objects in VCL can only be used in a
  method called using Synchronize, for example,

      Synchronize(UpdateCaption);

  and UpdateCaption could look like,

    procedure CLifeThread.UpdateCaption;
    begin
      Form1.Caption := 'Updated in a thread';
    end; }

{ CLifeThread }

procedure CLifeThread.Execute;
//var step: Longint;
begin
  { Place thread code here }

//  curIF := CifGravity.Create;
  FreeOnTerminate:=False;
  while TRUE do begin
//    OneStep;
    fmInfField.OneStep;
    if Terminated then exit;
    try
      Sleep(Abs(StrToInt(fmInfField.edSleepTime.Text)));
    except
      on  EConvertError do;
    end;
  end;
end;

end.
