unit ifGravity;

interface
uses informationfield, BoolField;

type               //   
  CifGravity = class(CInformatiomField)
    public
      procedure OneStep(
        ColCount, RowCount: Longint;
        var boolCell: TBoolField;  var trackCell: TBoolField;
        var nextPopulation: Longint;
        var bornPopulation, todPopulation: Integer ); override;
  end;

var
  curIfGravity: CifGravity;

implementation
uses Windows, Sysutils;

procedure CifGravity.OneStep(
      ColCount, RowCount: Longint;
      var boolCell: TBoolField; var trackCell: TBoolField;
      var nextPopulation: Longint;
      var bornPopulation, todPopulation: Integer );
var i, j, l: Longint;

var tmpCell1, tmpCell2: Boolean;
begin
  bornPopulation := 0;
  todPopulation := 0;

  for  i:=0 to ColCount-1 do
    for j:=RowCount-1 downto 0 do begin
      if j = 0 then l := RowCount-1 else l := j-1;
      tmpCell1 := boolCell[i,j] OR boolCell[i,l];
      tmpCell2 := boolCell[i,j] AND boolCell[i,l];
      boolCell[i,j] :=  tmpCell1;
      boolCell[i,l] :=  tmpCell2;
  end;

  nextPopulation := 0;
  for  i:=0 to ColCount-1 do
    for j:=0 to RowCount-1 do begin
      if boolCell[i,j] then Inc(nextPopulation);

  end;


end;




end.
